#include "SDIO.h"
#include "uart.h"
#include "sdio_sdcard.h"
#include "stdio.h"
#include <string.h>
#include "diskio.h"	
#include "ff.h"	
//TK499
void SDIO1_GPIOInitRemap(void)
{
	#if (0)
    GPIOC->CRL  = 0x0;   
    GPIOC->AFRL = 0x0;
    GPIOC->AFRL = 0xCCCCCCCC;
    GPIOC->CRL  = 0xAAAAAAAA;   //GPIOC_Pin_6 clear
	#else
    GPIOD->AFRL &= 0xFF000000;
		GPIOD->AFRL |= 0x00CCCCCC;
		GPIOD->CRL  &= 0xFF000000;   
		GPIOD->CRL  |= 0x00aaaaaa;   
	#endif
}
void show_sdcard_info(void)
{
	switch(SDCardInfo.CardType)
	{
		case SDIO_STD_CAPACITY_SD_CARD_V1_1:printf((char *)("Card Type:SDSC V1.1\r\n"));break;
		case SDIO_STD_CAPACITY_SD_CARD_V2_0:printf((char *)("Card Type:SDSC V2.0\r\n"));break;
		case SDIO_HIGH_CAPACITY_SD_CARD:printf((char *)("Card Type:SDHC V2.0\r\n"));break;
		case SDIO_MULTIMEDIA_CARD:printf((char *)("Card Type:MMC Card\r\n"));break;
	}	
    printf((char *)"Card ManufacturerID:%d\r\n",SDCardInfo.SD_cid.ManufacturerID);	//ID
 	printf((char *)"Card RCA:%d\r\n",SDCardInfo.RCA);								//Եַ
	printf((char *)"Card Capacity:%d MB\r\n",(u32)(SDCardInfo.CardCapacity>>20));	//ʾ
 	printf((char *)"Card BlockSize:%d\r\n\r\n",SDCardInfo.CardBlockSize);			//ʾС
}
void Test_SDcard_read_TXT()
{
		u8   fs_temp_buf[512];
		FIL  file;
		FATFS ufs;
		u32 fs_cnt;
		FIL *filescr1 = &file;
		FRESULT f_res;
		f_res = f_mount (&ufs, "0:", 1);//ļϵͳ
		f_res = f_open(filescr1, "0:123.TXT",  FA_READ );
		fs_cnt = 512;
		do
  {
    f_res = f_read(filescr1, fs_temp_buf, 512, &fs_cnt);
//		printf("%s",fs_temp_buf);//printfӡ
		UartSendGroup(fs_temp_buf,fs_cnt);
  }
	while(fs_cnt > 0);
}
void SDIO_GPIO_Test(void) //תʹõIO
{
  u32 i,j;
  GPIOD->CRL  &= 0xFF000000;   
  GPIOD->CRL  |= 0x00333333;  
  
  GPIOD->BRR = 0x3F;
  
  for(i = 0;i < 6;i ++)
  {
    GPIOD->BSRR = 1 << i;
  }
  for(i = 0;i < 6;i ++)
  {
    GPIOD->BRR = 1 << i;
  }
  GPIOD->BSRR = 0x3F;
  j = 100;
  while(j--)
  {
    GPIOD->ODR ^= 1<<4;
  }
  GPIOD->BSRR = 0x3F;
}

//TK499
void SDIO_Init(void) 
{
	SDIO_GPIO_Test();
  SDIO1_GPIOInitRemap();
	
//	RCC->APB2ENR |= 0x1<<11; //open sdio1 clkgate
	RCC->APB2ENR |= 0x1<<12; //open sdio2 clkgate
	
	TEST_SDIOx->MMC_CARDSEL = 0xC0;   //enable module, enable mmcclk
	TEST_SDIOx->MMC_CTRL    = 0x03|((0x7)<<3)|(1<<8);//4bit,low speed,1/16 divider,ʼʱõ		
//	TEST_SDIOx->MMC_INT_MASK = 0x01;  //unmask interrupt
	TEST_SDIOx->MMC_CRCCTL   = 0xC0; 

	
//	TEST_SDIOx->MMC_IO_MBCTL |= 0x8;//2019
	SD_Init();
//	while()
//	{
//	   printf("鲻Ϣ!\n");
//	}
	show_sdcard_info();
	Test_SDcard_read_TXT();
}

//==============  SD ==============//
// ⲿFLASHִ֧Сƣ2MB~512MBĬֻǰ2MB涼Ǵݣ128M	bit,ַҪ8λ
// FLASHûƷƣĿǰW25Q128GD人о麣šۺꡢꡭ

#define QSPI_FLASH_SAVE_APP_ADD 		0x00000  //BootloaderӦóϢλFLASHе0x00000λãƫơĿǰϢֻһSDRAMеʼλãһĳ
#define QSPI_FLASH_APP_DATA     0x400        //ƫ1KBǳĴ洢λ
char program_updata(char *filename)
{
	FATFS fs;            // Work area (file system object) for logical drive
	FIL fsrc;      			// file objects
	FRESULT res;         // FatFs function common result code
	UINT br;         		// File R/W count
	
	u8 Buf[512];
	u32 addTemp=QSPI_FLASH_APP_DATA + QSPI_FLASH_SAVE_APP_ADD;
	u32	 temp=0,bin_size,erasedAdd;
	erasedAdd=QSPI_FLASH_SAVE_APP_ADD;
  res = f_mount (&fs, "0:", 1);//ļϵͳ
  res = f_open(&fsrc, filename, FA_OPEN_EXISTING | FA_READ);	 //򿪴ļ
	
  if(res!=FR_OK){ //ļڴ
		 f_close(&fsrc);
     f_mount (NULL, "0:", 1);//עļϵͳ
		 return 0;
  }
	bin_size= fsrc.obj.objsize;//ȡļ
	if(bin_size==0)
	{
		f_close(&fsrc);
    f_mount (NULL, "0:", 1);//עļϵͳ
		return 0;
	}
	if(bin_size<= 1024*1024*2)//Ŀǰ趨FLASH 洢2MB
		{
			bin_size+=0x10000;
			while(erasedAdd<bin_size)
			{
				QFLASH_FunErase(erasedAdd,1);//eType 0:SE_Com , 1:BE64K_Com
				erasedAdd += 0x10000;
			}	
		}
		else
		{
			f_close(&fsrc);
      f_mount (NULL, "0:", 1);//עļϵͳ
		  return 0;
		}
	
		bin_size= fsrc.obj.objsize;
	do
    {
      f_read(&fsrc, Buf, 512, &br);
      QFLASH_FunProgram(addTemp, ( unsigned char *)(Buf), 512);
			addTemp+=512;
      bin_size -= 512; 
    }
   while(bin_size > 511);
		if(bin_size)
		{
			f_read(&fsrc, Buf, bin_size, &br);
			QFLASH_FunProgram(addTemp, ( unsigned char *)(Buf), bin_size);
		}
		//==============  дͷ ==============//
		*(u32*)(Buf)    =  0x70008000 ;//RAMеʼַKEILһ
		*(u32*)(Buf+4)  =  ~0x70008000 ;
		*(u32*)(Buf+8)  =  fsrc.obj.objsize;//򳤶
		*(u32*)(Buf+12) =  ~(fsrc.obj.objsize);	
		*(u32*)(Buf+16) =  0x12346789 ;
		*(u32*)(Buf+20) =  ~0x12346789 ;	
		QSPI_PageXbytesProgram_Standard_NoCheck(QSPI_FLASH_SAVE_APP_ADD, ( unsigned char *)(Buf), 30);//ͷĿǰֻдŵRAMʼַ
		
		f_close(&fsrc);//ɣرļ
		f_mount (NULL, "0:", 1);//עļϵͳ
		
		printf(" Updata OK! \r\n");
		return 1;
}

